

#include "BUILTIN.h"

#include "Nat.h"
extern OBJ _APair_5(OBJ);extern OBJ __APair_5;
extern OBJ _AIde_14(OBJ,OBJ);extern OBJ __AIde_14;

#include "Char.h"

#include "Int.h"
extern OBJ _ASeqMap_3(OBJ,OBJ);extern OBJ __ASeqMap_3;
extern OBJ _AMap_8(OBJ,OBJ,OBJ);extern OBJ __AMap_8;
extern OBJ _AMap_10(OBJ,OBJ,OBJ,OBJ);extern OBJ __AMap_10;
extern OBJ _AMap_14(OBJ,OBJ,OBJ);extern OBJ __AMap_14;
extern OBJ _AMap_16(OBJ,OBJ,OBJ);extern OBJ __AMap_16;
extern OBJ _AMap_20(OBJ,OBJ,OBJ);extern OBJ __AMap_20;
extern OBJ _AMap_31(OBJ,OBJ,OBJ,OBJ);extern OBJ __AMap_31;
extern OBJ _AMap_32(OBJ,OBJ,OBJ,OBJ);extern OBJ __AMap_32;
extern OBJ _AMap_33(OBJ,OBJ,OBJ);extern OBJ __AMap_33;
extern OBJ _AMapConv_4(OBJ,OBJ);extern OBJ __AMapConv_4;
extern OBJ _AMapConv_5(OBJ,OBJ);extern OBJ __AMapConv_5;
extern OBJ __ATree_7;
OBJ __AIdeMap_3; /* {} */
extern OBJ _AIdeMap_4(OBJ);OBJ __AIdeMap_4; /* {}? */
extern OBJ _AIdeMap_5(OBJ,OBJ,OBJ);OBJ __AIdeMap_5; /* def */
extern OBJ _AIdeMap_6(OBJ,OBJ);OBJ __AIdeMap_6; /* undef */
extern OBJ _AIdeMap_7(OBJ,OBJ);OBJ __AIdeMap_7; /* def? */
extern OBJ _AIdeMap_8(OBJ,OBJ,OBJ);OBJ __AIdeMap_8; /* upd */
extern OBJ _AIdeMap_9(OBJ,OBJ);OBJ __AIdeMap_9; /* <+ */
extern OBJ _AIdeMap_10(OBJ,OBJ,OBJ);OBJ __AIdeMap_10; /* extend */
extern OBJ _AIdeMap_11(OBJ,OBJ);OBJ __AIdeMap_11; /* ! */
extern OBJ _AIdeMap_12(OBJ,OBJ);OBJ __AIdeMap_12; /* !? */
extern OBJ _AIdeMap_13(OBJ);OBJ __AIdeMap_13; /* dom */
extern OBJ _AIdeMap_14(OBJ);OBJ __AIdeMap_14; /* implode */
extern OBJ _AIdeMap_15(OBJ);OBJ __AIdeMap_15; /* explode */
extern OBJ _AIdeMap_16(OBJ);OBJ __AIdeMap_16; /* abs */
extern OBJ _AIdeMap_17(OBJ);OBJ __AIdeMap_17; /* abs? */
extern OBJ _AIdeMap_18(OBJ);OBJ __AIdeMap_18; /* rep */

extern OBJ _AIdeMap_4(OBJ x1) /* {}? */
{OBJ r;
 if(ISPRM(x1)){
  r=__ABUILTIN_5;
 }else{
  if(EXPRD(x1,1)){
   DSPRD(x1);
  }else{
   DCPRD(x1,1);}
  r=__ABUILTIN_3;}
 return r;}

extern OBJ _AIdeMap_5(OBJ x1,OBJ x2,OBJ x3) /* def */
{OBJ r;
 CPCLS(__AIde_14,1);
 r=_AMap_31(__AIde_14,x1,x2,x3);
 return r;}

extern OBJ _AIdeMap_6(OBJ x1,OBJ x2) /* undef */
{OBJ r;
 CPCLS(__AIde_14,1);
 r=_AMap_8(__AIde_14,x1,x2);
 return r;}

extern OBJ _AIdeMap_7(OBJ x1,OBJ x2) /* def? */
{OBJ r;
 CPCLS(__AIde_14,1);
 r=_AMap_20(__AIde_14,x1,x2);
 return r;}

extern OBJ _AIdeMap_8(OBJ x1,OBJ x2,OBJ x3) /* upd */
{OBJ r;
 CPCLS(__AIde_14,1);
 r=_AMap_32(__AIde_14,x2,x3,x1);
 return r;}

extern OBJ _AIdeMap_9(OBJ x1,OBJ x2) /* <+ */
{OBJ r;
 CPCLS(__AIde_14,1);
 r=_AMap_14(__AIde_14,x1,x2);
 return r;}

extern OBJ _AIdeMap_10(OBJ x1,OBJ x2,OBJ x3) /* extend */
{OBJ r;
 CPCLS(__AIde_14,1);
 r=_AMap_10(__AIde_14,x1,x2,x3);
 return r;}

extern OBJ _AIdeMap_11(OBJ x1,OBJ x2) /* ! */
{OBJ r;
 CPCLS(__AIde_14,1);
 r=_AMap_16(__AIde_14,x1,x2);
 return r;}

extern OBJ _AIdeMap_12(OBJ x1,OBJ x2) /* !? */
{OBJ r;
 CPCLS(__AIde_14,1);
 r=_AMap_33(__AIde_14,x1,x2);
 return r;}

extern OBJ _AIdeMap_13(OBJ x1) /* dom */
{OBJ r;
 CPCLS(__APair_5,1);
 CPCLS(__AIde_14,1);
 {OBJ x2;
  x2=_AMapConv_4(__AIde_14,x1);
  r=_ASeqMap_3(__APair_5,x2);}
 return r;}

extern OBJ _AIdeMap_14(OBJ x1) /* implode */
{OBJ r;
 CPCLS(__AIde_14,1);
 r=_AMapConv_5(__AIde_14,x1);
 return r;}

extern OBJ _AIdeMap_15(OBJ x1) /* explode */
{OBJ r;
 CPCLS(__AIde_14,1);
 r=_AMapConv_4(__AIde_14,x1);
 return r;}

extern OBJ _AIdeMap_16(OBJ x1) /* abs */
{OBJ r;
 r=x1;
 return r;}

extern OBJ _AIdeMap_17(OBJ x1) /* abs? */
{OBJ r;
 FREE(x1,1);
 r=__ABUILTIN_5;
 return r;}

extern OBJ _AIdeMap_18(OBJ x1) /* rep */
{OBJ r;
 r=x1;
 return r;}


init_AIdeMap()
{
 static int visited=0; if(visited) return; visited=1;
 init_ANat();
 init_APair();
 init_ASeq();
 init_AOption();
 init_AIde();
 init_AFormat();
 init_AString();
 init_ACom();
 init_AStream();
 init_AVoid();
 init_AFmt();
 init_AChar();
 init_AFile();
 init_AInt();
 init_ASeqMap();
 init_AMap();
 init_AMapConv();
 init_ASet();
 init_ASetByBST();
 init_ABSTree();
 init_ATree();
 init_ASeqConv();
 CLS(1,_AIdeMap_18,__AIdeMap_18);
 CLS(1,_AIdeMap_17,__AIdeMap_17);
 CLS(1,_AIdeMap_16,__AIdeMap_16);
 CLS(1,_AIdeMap_15,__AIdeMap_15);
 CLS(1,_AIdeMap_14,__AIdeMap_14);
 CLS(1,_AIdeMap_13,__AIdeMap_13);
 CLS(2,_AIdeMap_12,__AIdeMap_12);
 CLS(2,_AIdeMap_11,__AIdeMap_11);
 CLS(3,_AIdeMap_10,__AIdeMap_10);
 CLS(2,_AIdeMap_9,__AIdeMap_9);
 CLS(3,_AIdeMap_8,__AIdeMap_8);
 CLS(2,_AIdeMap_7,__AIdeMap_7);
 CLS(2,_AIdeMap_6,__AIdeMap_6);
 CLS(3,_AIdeMap_5,__AIdeMap_5);
 CLS(1,_AIdeMap_4,__AIdeMap_4);
 __AIdeMap_3=__ATree_7;}

